package com.jasamedika.medifirst2000.entities;

import java.io.Serializable;
import org.hibernate.envers.Audited;
import javax.persistence.*;

import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.BaseMaster;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.BaseMaster;
import com.jasamedika.medifirst2000.helper.Caption;
import org.hibernate.envers.Audited;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 * class BahanProduk
 * 
 * @author Generator
 */
@Entity // @Audited
@Table(name = "BahanProduk_M")
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class BahanProduk extends BaseMaster {
	@NotNull(message = "Kd Bahan Produk tidak boleh kosong")
	@Column(name = "KdBahanProduk", nullable = false)
	@Caption(value = "Kode Bahan Produk")
	private Byte kdBahanProduk;

	public void setKdBahanProduk(Byte kdBahanProduk) {
		this.kdBahanProduk = kdBahanProduk;
	}

	public Byte getKdBahanProduk() {
		return this.kdBahanProduk;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ObjectDepartemenFk")
	@NotNull(message = "Kd Departemen tidak boleh kosong")

	@Caption(value = "Object Departemen")
	private Departemen departemen;

	public void setDepartemen(Departemen departemen) {
		this.departemen = departemen;
	}

	public Departemen getDepartemen() {
		return this.departemen;
	}

	@Column(name = "ObjectDepartemenFk", insertable = false, updatable = false)
	private Integer departemenId;

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ObjectKelompokProdukFk")

	@Caption(value = "Object Kelompok Produk")
	private KelompokProduk kelompokProduk;

	public void setKelompokProduk(KelompokProduk kelompokProduk) {
		this.kelompokProduk = kelompokProduk;
	}

	public KelompokProduk getKelompokProduk() {
		return this.kelompokProduk;
	}

	@Column(name = "ObjectKelompokProdukFk", insertable = false, updatable = false, nullable = false)
	private Integer kelompokProdukId;

	@NotNull(message = "Nama Bahan Produk tidak boleh kosong")
	@Column(name = "NamaBahanProduk", nullable = false, length = 30)
	@Caption(value = "Nama Bahan Produk")
	private String namaBahanProduk;

	public void setNamaBahanProduk(String namaBahanProduk) {
		this.namaBahanProduk = namaBahanProduk;
	}

	public String getNamaBahanProduk() {
		return this.namaBahanProduk;
	}

	@NotNull(message = "QBahan Produk tidak boleh kosong")
	@Column(name = "QBahanProduk", nullable = false)
	@Caption(value = "QBahan Produk")
	private Byte qBahanProduk;

	public void setqBahanProduk(Byte qBahanProduk) {
		this.qBahanProduk = qBahanProduk;
	}

	public Byte getqBahanProduk() {
		return this.qBahanProduk;
	}

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "public.bahanproduk_m_id_seq")
	@javax.persistence.SequenceGenerator(name = "public.bahanproduk_m_id_seq", sequenceName = "public.bahanproduk_m_id_seq", allocationSize = 1)
	@Column(name = "id")
	protected Integer id;

	public Integer getId() {

		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}
}